#!/usr/bin/ruby

require 'optparse'
require 'logger'
require_relative '../lib/spider_framework'

options = {
  log_level: Logger::DEBUG,
  log_only: false
}

ARGV.unshift('-h') if ARGV.empty?
OptionParser.new do |opts|
  opts.banner = <<~BANNER
    执行一个爬虫文件
    用法：spider [options] file

  BANNER

  opts.on("-l", "--log-level=LEVEL", "设置日志级别，可选值包括 FATAL、ERROR、WARN、INFO、DEBUG（默认）") do |level|
    if %w[FATAL ERROR WARN INFO DEBUG].include?(level)
      options[:log_level] = Logger.const_get(level)
    else
      raise OptionParser::InvalidArgument, level
    end
  end

  opts.on("-n", "--log-only=A,B,C", Array, "只允许设置的日志器名称在控制台显示") do |names|
    options[:log_only] = names
  end
end.parse!

SpiderFramework::EnhancedLogger.level = options[:log_level]
SpiderFramework::EnhancedLogger.names_only = options[:log_only]

program_name = ARGV.shift
load program_name
